--- gcc/ChangeLog	(revision 194837)
+++ gcc/ChangeLog	(working copy)
@@ -1,5 +1,9 @@
 2013-01-03  Jakub Jelinek  <jakub@redhat.com>
 
+	* gcc.c (process_command): Update copyright notice dates.
+	* gcov.c (print_version): Likewise.
+	* gcov-dump.c (print_version): Likewise.
+
 	PR rtl-optimization/55838
 	* loop-iv.c (iv_number_of_iterations): Call lowpart_subreg on
 	iv0.step, iv1.step and step.
--- gcc/fortran/ChangeLog	(revision 194837)
+++ gcc/fortran/ChangeLog	(working copy)
@@ -1,3 +1,8 @@
+2013-01-03  Jakub Jelinek  <jakub@redhat.com>
+
+	* gfortranspec.c (lang_specific_driver): Update copyright notice
+	dates.
+
 2012-12-28  Janus Weil  <janus@gcc.gnu.org>
 
 	PR fortran/55692
--- gcc/fortran/gfortranspec.c	(revision 194837)
+++ gcc/fortran/gfortranspec.c	(working copy)
@@ -1,6 +1,6 @@
 /* Specific flags and argument handling of the Fortran front-end.
    Copyright (C) 1997, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
-   2007, 2008, 2009, 2010, 2011, 2012
+   2007, 2008, 2009, 2010, 2011, 2012, 2013
    Free Software Foundation, Inc.
 
 This file is part of GCC.
@@ -301,7 +301,7 @@ lang_specific_driver (struct cl_decoded_
 
 	case OPT__version:
 	  printf ("GNU Fortran %s%s\n", pkgversion_string, version_string);
-	  printf ("Copyright %s 2012 Free Software Foundation, Inc.\n\n",
+	  printf ("Copyright %s 2013 Free Software Foundation, Inc.\n\n",
 		  _("(C)"));
 	  printf (_("GNU Fortran comes with NO WARRANTY, to the extent permitted by law.\n\
 You may redistribute copies of GNU Fortran\n\
--- gcc/gcc.c	(revision 194837)
+++ gcc/gcc.c	(working copy)
@@ -1,7 +1,7 @@
 /* Compiler driver program that can handle many languages.
    Copyright (C) 1987, 1989, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
    1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009,
-   2010, 2011, 2012
+   2010, 2011, 2012, 2013
    Free Software Foundation, Inc.
 
 This file is part of GCC.
@@ -6714,7 +6714,7 @@ main (int argc, char **argv)
     {
       printf (_("%s %s%s\n"), progname, pkgversion_string,
 	      version_string);
-      printf ("Copyright %s 2012 Free Software Foundation, Inc.\n",
+      printf ("Copyright %s 2013 Free Software Foundation, Inc.\n",
 	      _("(C)"));
       fputs (_("This is free software; see the source for copying conditions.  There is NO\n\
 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"),
--- gcc/gcov-dump.c	(revision 194837)
+++ gcc/gcov-dump.c	(working copy)
@@ -1,6 +1,6 @@
 /* Dump a gcov file, for debugging use.
    Copyright (C) 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
-   2012 Free Software Foundation, Inc.
+   2012, 2013 Free Software Foundation, Inc.
    Contributed by Nathan Sidwell <nathan@codesourcery.com>
 
 Gcov is free software; you can redistribute it and/or modify
@@ -135,7 +135,7 @@ static void
 print_version (void)
 {
   printf ("gcov-dump %s%s\n", pkgversion_string, version_string);
-  printf ("Copyright (C) 2012 Free Software Foundation, Inc.\n");
+  printf ("Copyright (C) 2013 Free Software Foundation, Inc.\n");
   printf ("This is free software; see the source for copying conditions.\n"
   	  "There is NO warranty; not even for MERCHANTABILITY or \n"
 	  "FITNESS FOR A PARTICULAR PURPOSE.\n\n");
--- gcc/gcov.c	(revision 194837)
+++ gcc/gcov.c	(working copy)
@@ -1,7 +1,8 @@
 /* Gcov.c: prepend line execution counts and branch probabilities to a
    source file.
    Copyright (C) 1990, 1991, 1992, 1993, 1994, 1996, 1997, 1998, 1999,
-   2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012
+   2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
+   2012, 2013
    Free Software Foundation, Inc.
    Contributed by James E. Wilson of Cygnus Support.
    Mangled by Bob Manson of Cygnus Support.
@@ -489,7 +490,7 @@ static void
 print_version (void)
 {
   fnotice (stdout, "gcov %s%s\n", pkgversion_string, version_string);
-  fprintf (stdout, "Copyright %s 2012 Free Software Foundation, Inc.\n",
+  fprintf (stdout, "Copyright %s 2013 Free Software Foundation, Inc.\n",
 	   _("(C)"));
   fnotice (stdout,
 	   _("This is free software; see the source for copying conditions.\n"
--- gcc/java/ChangeLog	(revision 194837)
+++ gcc/java/ChangeLog	(working copy)
@@ -1,3 +1,7 @@
+2013-01-03  Jakub Jelinek  <jakub@redhat.com>
+
+	* jcf-dump.c (version): Update copyright notice dates.
+
 2012-11-16  Diego Novillo  <dnovillo@google.com>
 
 	Adjust for new vec API (http://gcc.gnu.org/wiki/cxx-conversion/cxx-vec)
--- gcc/java/jcf-dump.c	(revision 194837)
+++ gcc/java/jcf-dump.c	(working copy)
@@ -2,7 +2,8 @@
    Functionally similar to Sun's javap.
 
    Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
-   2006, 2007, 2008, 2009, 2010, 2011, 2012 Free Software Foundation, Inc.
+   2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013
+   Free Software Foundation, Inc.
 
 This file is part of GCC.
 
@@ -1228,7 +1229,7 @@ static void
 version (void)
 {
   printf ("jcf-dump %s%s\n\n", pkgversion_string, version_string);
-  printf ("Copyright %s 2012 Free Software Foundation, Inc.\n", _("(C)"));
+  printf ("Copyright %s 2013 Free Software Foundation, Inc.\n", _("(C)"));
   printf (_("This is free software; see the source for copying conditions.  There is NO\n"
 	    "warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"));
   exit (0);
--- libjava/ChangeLog	(revision 194837)
+++ libjava/ChangeLog	(working copy)
@@ -1,3 +1,9 @@
+2013-01-03  Jakub Jelinek  <jakub@redhat.com>
+
+	* gnu/gcj/convert/Convert.java (version): Update copyright notice
+	dates.
+	* gnu/gcj/tools/gcj_dbtool/Main.java (main): Likewise.
+
 2012-12-19  Matthias Klose  <doko@ubuntu.com>
 
         Import GNU Classpath (20121202).
--- libjava/classpath/ChangeLog.gcj	(revision 194837)
+++ libjava/classpath/ChangeLog.gcj	(working copy)
@@ -1,3 +1,9 @@
+2013-01-03  Jakub Jelinek  <jakub@redhat.com>
+
+	* gnu/java/rmi/registry/RegistryImpl.java (version): Update
+	copyright notice dates.
+	* tools/gnu/classpath/tools/orbd/Main.java (run): Likewise.
+
 2012-12-03  Matthias Klose  <doko@ubuntu.com>
 
 	* configure.ac (AM_INIT_AUTOMAKE): Call with no-dist.
--- libjava/classpath/gnu/java/rmi/registry/RegistryImpl.java	(revision 194837)
+++ libjava/classpath/gnu/java/rmi/registry/RegistryImpl.java	(working copy)
@@ -1,6 +1,6 @@
 /* RegistryImpl.java --
    Copyright (c) 1996, 1997, 1998, 1999, 2002, 2005, 2008, 2009, 2010, 2011,
-   2012 Free Software Foundation, Inc.
+   2012, 2013 Free Software Foundation, Inc.
 
 This file is part of GNU Classpath.
 
@@ -111,7 +111,7 @@ public static void version() {
                            + System.getProperty("java.vm.name")
                            + ") "
                            + System.getProperty("java.vm.version"));
-        System.out.println("Copyright 2012 Free Software Foundation, Inc.");
+        System.out.println("Copyright 2013 Free Software Foundation, Inc.");
         System.out.println("This is free software; see the source for copying conditions.  There is NO");
         System.out.println("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.");
         System.exit(0);
--- libjava/classpath/tools/gnu/classpath/tools/orbd/Main.java	(revision 194837)
+++ libjava/classpath/tools/gnu/classpath/tools/orbd/Main.java	(working copy)
@@ -1,5 +1,5 @@
 /* NamingServicePersistent.java -- The persistent naming service.
-   Copyright (C) 2006, 2008, 2009, 2010, 2011, 2012
+   Copyright (C) 2006, 2008, 2009, 2010, 2011, 2012, 2013
    Free Software Foundation, Inc.
 
 This file is part of GNU Classpath.
@@ -180,7 +180,7 @@ public class Main
         System.out.println("GNU Classpath persistent naming service "
                            + "started at " + iorr.Internet.host + ":"
                            + iorr.Internet.port + " key 'NameService'.\n\n"
-                           + "Copyright (C) 2012 Free Software Foundation\n"
+                           + "Copyright (C) 2013 Free Software Foundation\n"
                            + "This tool comes with ABSOLUTELY NO WARRANTY. "
                            + "This is free software, and you are\nwelcome to "
                            + "redistribute it under conditions, defined in "
--- libjava/gnu/gcj/convert/Convert.java	(revision 194837)
+++ libjava/gnu/gcj/convert/Convert.java	(working copy)
@@ -1,5 +1,5 @@
-/* Copyright (C) 1999, 2002, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012
-   Free Software Foundation
+/* Copyright (C) 1999, 2002, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012,
+   2013 Free Software Foundation
 
    This file is part of libgcj.
 
@@ -46,7 +46,7 @@ public class Convert
 		       + ") "
 		       + System.getProperty("java.vm.version"));
     System.out.println();
-    System.out.println("Copyright (C) 2012 Free Software Foundation, Inc.");
+    System.out.println("Copyright (C) 2013 Free Software Foundation, Inc.");
     System.out.println("This is free software; see the source for copying conditions.  There is NO");
     System.out.println("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.");
     System.exit(0);
--- libjava/gnu/gcj/tools/gcj_dbtool/Main.java	(revision 194837)
+++ libjava/gnu/gcj/tools/gcj_dbtool/Main.java	(working copy)
@@ -1,4 +1,4 @@
-/* Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012
+/* Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013
    Free Software Foundation
 
    This file is part of libgcj.
@@ -47,7 +47,7 @@ public class Main
 			   + ") "
 			   + System.getProperty("java.vm.version"));
 	System.out.println();
-	System.out.println("Copyright 2012 Free Software Foundation, Inc.");
+	System.out.println("Copyright 2013 Free Software Foundation, Inc.");
 	System.out.println("This is free software; see the source for copying conditions.  There is NO");
 	System.out.println("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.");
 	return;
--- libmudflap/ChangeLog	(revision 194837)
+++ libmudflap/ChangeLog	(working copy)
@@ -1,3 +1,7 @@
+2013-01-03  Jakub Jelinek  <jakub@redhat.com>
+
+	* mf-runtime.c (__mf_usage): Update copyright notice dates.
+
 2012-12-15  Alexandre Oliva <aoliva@redhat.com>
 
 	* mf-hooks1.c (free): Return on NULL before any logging.
--- libmudflap/mf-runtime.c	(revision 194837)
+++ libmudflap/mf-runtime.c	(working copy)
@@ -1,6 +1,6 @@
 /* Mudflap: narrow-pointer bounds-checking by tree rewriting.
-   Copyright (C) 2002, 2003, 2004, 2005, 2006, 2008, 2009, 2010, 2011, 2012
-   Free Software Foundation, Inc.
+   Copyright (C) 2002, 2003, 2004, 2005, 2006, 2008, 2009, 2010, 2011, 2012,
+   2013 Free Software Foundation, Inc.
    Contributed by Frank Ch. Eigler <fche@redhat.com>
    and Graydon Hoare <graydon@redhat.com>
    Splay Tree code originally by Mark Mitchell <mark@markmitchell.com>,
@@ -448,7 +448,7 @@ __mf_usage ()
 
   fprintf (stderr,
            "This is a %s%sGCC \"mudflap\" memory-checked binary.\n"
-           "Mudflap is Copyright (C) 2002-2012 Free Software Foundation, Inc.\n"
+           "Mudflap is Copyright (C) 2002-2013 Free Software Foundation, Inc.\n"
            "\n"
            "Unless setuid, a program's mudflap options be set by an environment variable:\n"
            "\n"